SuperStrict
Global vb%,mc%,id%,_:TAudioSample,za%
Const ja#=.01
Global r%=1,jd%=OpenALInstalled()
For Local ef$=EachIn AppArgs
DebugLog "arg: "+ef
If "--quiet".Contains(ef)
r=0
DebugLog "quiet"
Exit
EndIf
Next
Function di()
If Not r Return
If Not jd
r=0
DebugLog "NOTICE: FOR OPTIMAL GAMEPLAY, IT IS RECOMMENTED TO USE OpenAL!"
Return
EndIf
EnableOpenALAudio
SetAudioDriver "OpenAL"
vb=alcOpenDevice(Null)
Assert vb
mc=alcCreateContext(vb,Null)
Assert mc
alcMakeContextCurrent mc
oc
alListener3f AL_POSITION,0,0,0
oc
alGenBuffers 1,Varptr(id)
oc
EndFunction
Function zh()
If Not r Return
_=LoadAudioSample("horn.wav")
Local mb%=1
Select _.format
Case SF_MONO8
za=AL_FORMAT_MONO8
DebugLog "MONO8"
Case SF_MONO16LE
za=AL_FORMAT_MONO16
mb=2
?BigEndian
_=_.Convert(SF_MONO16BE)
?
DebugLog "MONO16LE"
Case SF_MONO16BE
za=AL_FORMAT_MONO16
mb=2
?LittleEndian
_=_.Convert(SF_MONO16LE)
?
DebugLog "MONO16BE"
Case SF_STEREO8
za=AL_FORMAT_STEREO8
mb=2
DebugLog "STEREO8"
Case SF_STEREO16LE
za=AL_FORMAT_STEREO16
mb=4
?BigEndian
_=_.Convert(SF_STEREO16BE)
?
DebugLog "STEREO16LE"
Case SF_STEREO16BE
za=AL_FORMAT_STEREO16
mb=4
?LittleEndian
_=_.Convert(SF_STEREO16LE)
?
DebugLog "STEREO16BE"
Default
RuntimeError "Unknown sample format"
EndSelect
alBufferData id,za,_.samples,_.length*mb,_.hertz
EndFunction
Function yg()
If Not r Return
alcDestroyContext mc
alcCloseDevice vb
oc
EndFunction
Function oc()
If Not r Return
Local od%=alGetError()
Select od
Case AL_INVALID_NAME
RuntimeError "invalid name"
Case AL_INVALID_ENUM
RuntimeError "invalid enum"
Case AL_INVALID_VALUE
RuntimeError "invalid value"
Case AL_INVALID_OPERATION
RuntimeError "invalid command"
Case AL_OUT_OF_MEMORY
RuntimeError "out of memory"
Case AL_NO_ERROR
Default
RuntimeError "unknown error"
EndSelect
od=alcGetError(vb)
Select od
Case ALC_INVALID_DEVICE
RuntimeError "invalid device"
Case ALC_INVALID_CONTEXT
RuntimeError "invalid context"
Case ALC_INVALID_ENUM
RuntimeError "invalid enum"
Case ALC_INVALID_VALUE
RuntimeError "invalid value"
Case ALC_NO_ERROR
Default
RuntimeError "unknown error"
EndSelect
EndFunction
Global cc%,nc%,yd%=0
Const hh%=6000,ih%=10000,kf#=20,gh#=kf*kf
Type u Extends ga
Field aa%,s#,w#,ad#=1.0,sf%=0
Global t:TImage
Const x#=45
Method New()
Self.p.AddLast Self
If r
alGenSources 1,Varptr(Self.aa)
alSourcei Self.aa,AL_BUFFER,id
alSourcei Self.aa,AL_LOOPING,AL_TRUE
alSourcef Self.aa,AL_CONE_OUTER_GAIN,Self.x
EndIf
yd :+ 1
EndMethod
Method Delete()
Self.ca
DebugLog "Delete Horn"
EndMethod
Method ca()
If Self.aa
alDeleteSources 1,Varptr(Self.aa)
Self.aa=0
EndIf
Self.p.Remove Self
yd :- 1
EndMethod
Method oi(b#,a#)
Self.b=b
Self.a=a
If Not r Return
alSource3f Self.aa,AL_POSITION,b*ja,0,a*ja
EndMethod
Method si(s#,w#)
Self.s=s
Self.w=w
If Not r Return
alSource3f Self.aa,AL_VELOCITY,s*ja,0,w*ja
EndMethod
Method ri(ad#)
If Not r Return
alSourcef Self.aa,AL_PITCH,ad
EndMethod
Method xc()
If Not r Return
alSourcePlay Self.aa
EndMethod
Function f:u(b#,a#,s#,w#)
Local q:u=New u
q.oi b,a
q.si s,w
q.xc
Return q
EndFunction
Function yc(ad#)
For Local cb:u=EachIn Self.p
cb.ri ad
Next
EndFunction
Function sk()
Self.p.Clear
EndFunction
Method h(da#,ea#)
DrawImage Self.t,Self.b+da,Self.a+ea
Local s#=Self.b-.b,w#=Self.a-.a,_g#=s*s+w*w
If _g < gh
Self.sf=1
If ma > 1.201 c.g re
ElseIf Self.sf
c.g we
EndIf
EndMethod
Method kb()
bb :+ 1
c.g fe
If v < 1.0 c.g ze
Local ce%=MilliSecs()
If nc And ce-nc < ih
c.g ie
c.g fd
ElseIf cc
If ce-cc < hh
c.g fd
EndIf
nc=cc
EndIf
cc=ce
If bb > 1 c.g ge
If bb > 2 c.g he
Self.ca
If bb >= ae ob=aj
EndMethod
Function tk(da#,ea#)
For Local cb:u=EachIn Self.p
cb.h da,ea
Next
EndFunction
EndType
Function _f(b#,a#)
If Not r Return
alListener3f AL_POSITION,b*ja,0,a*ja
EndFunction
Function _d(s#,w#)
If Not r Return
alListener3f AL_VELOCITY,s*ja,0,w*ja
EndFunction
Function zf(n#)
If Not r Return
Local mg#[]=[Float(Sin(n)),.0,Float(Cos(n)),.0,1.0,.0]
alListenerfv AL_ORIENTATION,mg
EndFunction
Function bh(o#[],eb#,fb#,tc#=.8)
SetBlend LIGHTBLEND
Local bc#[o.length]
For Local d%=0 Until o.length Step 2
Local b#=o[d],a#=o[d+1],s#=b-eb,w#=a-fb
s :* tc
w :* tc
b=eb+s
a=fb+w
bc[d]=b
bc[d+1]=a
Next
DrawPoly bc
Local vf%,mf%,ua%
GetColor vf,mf,ua
glBegin GL_TRIANGLE_STRIP
For Local d%=0 To o.length Step 2
Local i%=d Mod o.length
SetColor 0,0,0
glVertex2f o[i],o[i+1]
SetColor vf,mf,ua
glVertex2f bc[i],bc[i+1]
Next
glEnd
EndFunction
Function ah(o#[],tc#=.8)
Local eb#,fb#
nh o,eb,fb
bh o,eb,fb,tc
EndFunction
Function nh(o#[],eb# Var,fb# Var)
Local m#,k#
For Local d%=0 Until o.length Step 2
m :+ o[d]
k :+ o[d+1]
Next
eb=m/o.length*2
fb=k/o.length*2
EndFunction
Function tg#[](b#,a#,n#,x#,wa#,cd#=1.0)
Local ud#=n-x*.5,yf#=n+x*.5,bf%=x/cd,q#[bf*2+6]
q[0]=b
q[1]=a
q[2]=b+Sin(ud)*wa
q[3]=a+Cos(ud)*wa
Local kd#=ud
For Local d%=0 Until bf
q[4+d*2]=b+Sin(kd)*wa
q[5+d*2]=a+Cos(kd)*wa
kd :+ cd
Next
q[q.length-2]=b+Sin(yf)*wa
q[q.length-1]=a+Cos(yf)*wa
Return q
EndFunction
GCSetMode 2
SetGraphicsDriver GLMax2DDriver()
Const m%=800,k%=600
Graphics m,k
SeedRnd MilliSecs()
Global e#[5,2],lc#=.0,ma#=1.2,v#=1.0,dc#=1.0,kc%=0,bb%=0
Const ae%=3
Global jc%=0,ec%=0,ub%=0
Const dj%=4000,uh%=10000,fj%=700
Global bg%
Const xk%=20000
Global _a:TImage,zd:TImage,x#,wa#,bd%=1,b#,a#,n#,ic:TTimer
Const ci#=1,bi#=80,ej#=6000,ji#=3
Global ob%=-1
Const aj%=250,jf%=50,zg%=250,gf%=50,jh%=20000
Global sc:TList=New TList,ya%=-1,vd#=.0,th#[]=[.5,1.0,2.0]
_i
Function sh()
di
zh
xh
yh
u.t=LoadImage("horn.png")
cg.t=LoadImage("clock.png")
dg.t=LoadImage("light.png")
eg.t=LoadImage("shoes.png")
fg.t=LoadImage("wind.png")
_a=LoadImage("bg.png")
MidHandleImage u.t
zd=LoadImage("player.png")
SetImageHandle zd,5,0
ic=CreateTimer(60)
xf
EndFunction
Function xc%(pf%)
ya=pf
vd=th[pf-1]
bg=MilliSecs()
Local lf%=0
Repeat
If lf < 10
lf :+ 1
EndIf
WaitTimer ic
Cls
SetBlend ALPHABLEND
If ya=1
SetAlpha .3
dh
SetAlpha 1
EndIf
SetColor 255,255,255
Local kh#[]=tg(b,a,n,x,wa,.6)
ah kh
SetAlpha .6
DrawOval b-20,a-20,40,40
SetAlpha 1
SetBlend SHADEBLEND
TileImage _a
For Local j:ga=EachIn ga.p
If tf(j.b,j.a)
j.ca
Else
j.h 0,0
EndIf
Next
SetColor 0,0,255
SetBlend SHADEBLEND
fh
SetBlend ALPHABLEND
SetRotation 180-n
SetAlpha 1
SetColor 255,255,255
DrawImage zd,b,a
SetRotation 0
If ob > 0
If ob < jf
SetAlpha ob/Float(jf)
DrawText "Sieg. Druecke [Esc] zum Beenden",0,0
SetAlpha 1
Else
DrawText "Sieg. Druecke [Esc] zum Beenden",0,0
EndIf
ob :- 1
EndIf
?Debug
DrawText "speedFactor: "+ma,0,20
DrawText "timeFactor: "+v,0,40
?
yi
Flip 0
If KeyDown(KEY_UP)
b :+ Sin(n)*ma*v
a :+ Cos(n)*ma*v
If b < 0 Or b > m Or a < 0 Or a > k c.g se
b=Max(0,Min(m,b))
a=Max(0,Min(k,a))
_f b,a
_d Sin(n)*ma*v,Cos(n)*ma*v
For Local j:ga=EachIn ga.p
If Abs(j.b-b)< 10 And Abs(j.a-a)< 10 j.kb
Next
bd=0
ElseIf Not bd
_d 0,0
bd=1
EndIf
If tf(b,a)
If Not zi()Return-1
Exit
EndIf
n :+(KeyDown(KEY_LEFT)-KeyDown(KEY_RIGHT))*ma*ji*v
If KeyDown(KEY_PAGEDOWN)
x=Min(x+1,bi)
yb
ElseIf KeyDown(KEY_PAGEUP)
x=Max(x-1,ci)
yb
EndIf
zf n
If kc
de Rnd(-.001,-.01)*v*vd
Else
de Rnd(0,.0003)*v*vd
If lc <= .0
c.g ke
kc=0
ub=0
DebugLog "water reset"
EndIf
EndIf
If jc <> 0 And jc < MilliSecs()
v=1.0
jc=0
u.yc 2.0
DebugLog "time reset"
EndIf
If ec <> 0 And ec < MilliSecs()
dc=1.0
ec=0
yb
DebugLog "light reset"
EndIf
If ub <> 0 And ub < MilliSecs()
kc=0
ub=0
DebugLog "water reset"
EndIf
If MouseDown(MOUSE_RIGHT)c.g oe
If KeyHit(KEY_ESCAPE)Return bb=ae
If KeyHit(KEY_SPACE)
If Not ag()Return-1
EndIf
If AppTerminate()Return-1
GCCollect
Forever
Return 0
EndFunction
Function bj()
yg
ni
GCCollect
End
EndFunction
Function zi%()
c.g qe
SetColor 255,255,255
Repeat
WaitTimer ic
Cls
DrawText "Game Over",0,0
Flip 0
If AppTerminate()Return 0
GCCollect
Until KeyHit(KEY_ESCAPE)
Return 1
EndFunction
Function xf()
ga.p.Clear
b=.0
a=.0
n=.0
lc=.0
de .0
ma=1.2
v=1.0
dc=1.0
kc=0
bb=0
jc=0
ec=0
ub=0
ob=-1
x=20.0
yb
u.yc 2.0
bd=1
_f .0,.0
_d .0,.0
zf .0
cc=0
nc=0
yd=0
sc.Clear
GCCollect
EndFunction
Function vg()
For Local d%=1 To 5
xg
Next
For Local d%=1 To ae
wg
Next
u.yc 2.0
GCCollect
EndFunction
Type ga Abstract
Global p:TList=New TList
Field b#,a#
Method h(da#,ea#)Abstract
Method kb()
EndMethod
Method ca()
EndMethod
EndType
Function de(cd#)
lc :+ cd
Local b#=m*lc,a#=k*lc
e[0,0]=b
e[0,1]=0
e[1,0]=b*.9
e[1,1]=a*.3
e[2,0]=b*.7
e[2,1]=a*.7
e[3,0]=b*.3
e[3,1]=a*.9
e[4,0]=0
e[4,1]=a
EndFunction
Function fh()
Local h#[12]
For Local d%=0 Until 5
h[d*2]=m-e[d,0]
h[d*2+1]=k-e[d,1]
Next
h[10]=m
h[11]=k
DrawPoly h
glBegin GL_TRIANGLE_STRIP
For Local d%=0 Until 5
SetColor 0,0,255
glVertex2f m-e[d,0],k-e[d,1]
SetColor 255,255,255
glVertex2f m-e[d,0]*1.1,k-e[d,1]*1.1
Next
SetAlpha 1
glEnd
EndFunction
Function tf%(b#,a#)
b=m-b
a=k-a
For Local d%=0 Until 5
If e[d,0]=b Return e[d,1]> a
Next
For Local d%=0 Until 4
If b > e[d,0]Or b < e[d+1,0]Continue
If a > e[d,1]And a > e[d+1,1]Continue
If a < e[d,1]And a < e[d+1,1]Return 1
Local _h#=Abs(e[d,1]-e[d+1,1])/Abs(e[d,0]-e[d+1,0]),ai#=Abs(e[d+1,1]-a)/Abs(e[d+1,0]-b)
If ai > _h Return 1
Next
Return 0
EndFunction
Type cg Extends ga
Global t:TImage
Method h(da#,ea#)
DrawImage Self.t,Self.b+da,Self.a+ea
EndMethod
Method kb()
c.g xe
If v < 1 c.g ye
v :* .5
jc=MilliSecs()+dj
u.yc v*2
Self.ca
EndMethod
Method ca()
Self.p.Remove Self
EndMethod
EndType
Type dg Extends ga
Global t:TImage
Method h(da#,ea#)
DrawImage Self.t,Self.b+da,Self.a+ea
EndMethod
Method kb()
c.g me
If dc > 1 c.g ne
dc :* 3
ec=MilliSecs()+uh
yb
Self.ca
If Self.p.IsEmpty()c.g le
EndMethod
Method ca()
Self.p.Remove Self
EndMethod
EndType
Type eg Extends ga
Global t:TImage
Method h(da#,ea#)
DrawImage Self.t,Self.b+da,Self.a+ea
EndMethod
Method kb()
c.g te
If ma > 1.201 c.g ue
ma :* 1.1
Self.ca
EndMethod
Method ca()
Self.p.Remove Self
EndMethod
EndType
Type fg Extends ga
Global t:TImage
Method h(da#,ea#)
DrawImage Self.t,Self.b+da,Self.a+ea
EndMethod
Method kb()
c.g je
If bb=0 c.g ve
kc=1
ub=MilliSecs()+fj
Self.ca
EndMethod
Method ca()
Self.p.Remove Self
EndMethod
EndType
Function nf(b# Var,a# Var)
b=Rnd(0,m-10)
If b < 20
a=Rnd(20,k-10)
ElseIf b > m-50
a=Rnd(0,k-30)
Else
a=Rnd(0,k-10)
EndIf
EndFunction
Function xg()
Local b#,a#
nf b,a
Local j:ga
Select Rand(1,4)
Case 1
j=New cg
Case 2
j=New dg
Case 3
j=New eg
Case 4
j=New fg
Default
RuntimeError "Internal error"
EndSelect
j.b=b
j.a=a
ga.p.AddLast j
EndFunction
Function wg()
Local b#,a#
nf b,a
u.f b,a,0,0
EndFunction
Function yb()
Local of#=x*.5
wa=Sqr(ej*dc/(2*Sin(of)*Cos(of)))
EndFunction
Function hf(b#,a#,ed#,uc#,wf%=30,wb%=3,n%=1)
Local xa%[3],db%[3],ab%[3]
GetColor xa[0],xa[1],xa[2]
If wb
SetColor 0,0,0
DrawRect b,a,ed,uc
b :+ wb
a :+ wb
ed :- wb*2
uc :- wb*2
EndIf
For Local d%=0 Until 3
db[d]=Min(255,xa[d]+wf)
ab[d]=Max(0,xa[d]-wf)
Next
glBegin GL_QUADS
If n=1
SetColor ab[0],ab[1],ab[2]
Else
SetColor db[0],db[1],db[2]
EndIf
glVertex2f b,a+uc
glVertex2f b+ed,a+uc
If n=1
SetColor db[0],db[1],db[2]
Else
SetColor ab[0],ab[1],ab[2]
EndIf
glVertex2f b+ed,a
glVertex2f b,a
glEnd
SetColor xa[0],xa[1],xa[2]
EndFunction
Function eh(hb$,b#,a#)
Local qf$[]=hb.Split("~n")
a :- TextHeight(hb)*qf.length/2
For Local wd$=EachIn qf
DrawText wd,b-TextWidth(wd)*.5,a
a :+ TextHeight(wd)
Next
EndFunction
Type na Extends TList
Field pc%[3],xb%[3],qc%[3],_a%[3]
Method h(b#,a#)
hc Self._a
hf b,a,(c.jb+c.rb)*Self.Count()+c.rb,c.ib+c.rb*2
b :+ c.rb
a :+ c.rb
For Local j:c=EachIn Self
If j.qb
hc Self.pc
ElseIf j.sd
hc Self.xb
Else
hc Self.qc
EndIf
j.h b,a
b :+ c.jb+c.rb
Next
EndMethod
Method _c(hi%,oh%,qg%,ii%,qh%,rg%,ki%,rh%,sg%,gi%,lh%,ng%)
Self.pc[0]=hi
Self.pc[1]=oh
Self.pc[2]=qg
Self.xb[0]=ii
Self.xb[1]=qh
Self.xb[2]=rg
Self.qc[0]=ki
Self.qc[1]=rh
Self.qc[2]=sg
Self._a[0]=gi
Self._a[1]=lh
Self._a[2]=ng
EndMethod
EndType
Const fe%=0,ge%=1,he%=2,fd%=3,ie%=4,we%=5,xe%=6,ye%=7,ze%=8,me%=9,ne%=10,le%=11,te%=12,ue%=13,re%=14,je%=15,ke%=16,ve%=17,qe%=18,pe%=19,oe%=20,se%=21,_e%=22,af%=23
Global pa:na,qa:na,ra:na,sa:na
Function xh()
pa=New na
qa=New na
ra=New na
sa=New na
pa._c 128,0,0,255,100,100,245,10,10,255,200,200
qa._c 128,128,0,255,255,100,200,200,10,240,240,200
ra._c 0,128,0,100,255,100,10,245,10,200,255,200
sa._c 0,0,128,100,100,255,50,50,245,200,200,255
c.f fe,"Sammle ein~nHorn",pa
c.f ge,"Sammle zwei~nHoerner",pa
c.f he,"Sammle drei~nHoerner",pa
c.f fd,"Sammle schnell~nzwei Hoerner",pa
c.f ie,"Sammle schnell~ndrei Hoerner",pa
c.f we,"Verfehle ein~nHorn knapp",pa
c.f xe,"Verlangsame~ndie Zeit",qa
c.f ye,"Verlangsame~ndie Zeit~ndoppelt",qa
c.f ze,"Sammle ein~nlangsames Horn",qa
c.f me,"Mache es~nheller",qa
c.f ne,"Mache es~nnoch heller",qa
c.f le,"Mache es~nheller -~nfuer nichts",qa
c.f te,"Gehe schneller",ra
c.f ue,"Gehe noch~nschneller",ra
c.f re,"Hoere den~nDoppler-Effekt",ra
c.f je,"Draenge das~nWasser zurueck",ra
c.f ke,"Draenge das~nWasser weg",ra
c.f ve,"Gewinne~nwertvolle Zeit",ra
c.f qe,"STIRB!",sa
c.f pe,"Bringe das~nProgramm zum~nAbsturz",sa
c.f oe,"Es gibt kein~nKontextmenue!",sa
c.f se,"Versuche~nzu entkommen",sa
c.f _e,"Gewinne das~nSpiel",sa
c.f af,"Gewinne das~nSpiel schnell",sa
EndFunction
Type c
Const gb%=24,jb#=120,ib#=80,rb#=10
Global ta:c[gb]
Field qb%=1,sd%,ac:na,hb$,zb%=0
Method h(b#,a#)
hf b,a,Self.jb,Self.ib
If Self.qb Return
SetColor 0,0,0
eh Self.hb,b+Self.jb/2,a+Self.ib/2
EndMethod
Function f(i%,hb$,ac:na)
Local ia:c=New c
ia.hb=hb
ia.ac=ac
ac.AddLast ia
Self.ta[i]=ia
EndFunction
Function g(i%)
If ya=1 Return
Local ia:c=Self.ta[i]
If Not ia.qb Return
ia.qb=0
ia.sd=1
ia.zb=zg
sc.AddLast ia
EndFunction
Function wh(ba:TBank)
Local i%,ua%
For i=0 Until Self.gb
If i Mod 8=0 ua=PeekByte(ba,i/8)
Local pg%=(ua Shr(i Mod 8))&1
Self.ta[i].qb=pg
Next
EndFunction
Function li(ba:TBank)
Local i%,ua%
For i=0 Until Self.gb
ua :| Self.ta[i].qb Shl(i Mod 8)
If i Mod 8=7
PokeByte(ba,i/8,ua)
ua=0
EndIf
Next
EndFunction
EndType
Function hc(ta%[])
SetColor ta[0],ta[1],ta[2]
EndFunction
Const rc$="db.dat"
Function yh()
If FileType(rc)<> 1 Return
Local ba:TBank=LoadBank(rc)
c.wh ba
Local ug%=PeekByte(ba,c.gb/8+1)
If ug c.g pe
PokeByte ba,c.gb/8+1,1
SaveBank ba,rc
EndFunction
Function ni%()
Local ba:TBank=CreateBank(c.gb/8+2)
c.li ba
PokeByte ba,c.gb/8+1,0
SaveBank ba,rc
EndFunction
Function ag%()
Repeat
WaitTimer ic
Cls
pa.h 0,0
qa.h 0,150
ra.h 0,300
sa.h 0,450
Flip 0
GCCollect
If AppTerminate()Return 0
Until KeyHit(KEY_ESCAPE)
For Local oa:c=EachIn c.ta
oa.sd=0
Next
Return 1
EndFunction
Function yi()
Local b#=m-c.jb,a#=k-c.ib
For Local oa:c=EachIn sc
hc oa.ac.xb
If oa.zb < gf
SetAlpha oa.zb/Float(gf)
Else
SetAlpha 1.0
EndIf
oa.h b,a
oa.zb :- 1
If oa.zb <= 0 sc.Remove oa
a :- c.ib
If a <= 0
a=k-c.ib
b :- c.jb
EndIf
Next
SetAlpha 1.0
EndFunction
Function _i()
sh
SetColor 255,255,255
Repeat
WaitTimer ic
Cls
DrawText "Spielen:",0,0
DrawText "einfach",200,0
DrawText "mittel",400,0
DrawText "schwer",600,0
DrawText "Errungenschaften",0,20
If Not jd
DrawText "OpenAL download",0,50
EndIf
Flip 0
If MouseHit(MOUSE_LEFT)
If MouseY()< 19 And MouseX()> 150
Local ya%
If MouseX()< 350
ya=1
ElseIf MouseX()< 550
ya=2
Else
ya=3
EndIf
vg
Select xc(ya)
Case 1
c.g _e
If MilliSecs()-bg < jh c.g af
Case-1
Exit
EndSelect
xf
ElseIf MouseY()< 39
If Not ag()Exit
ElseIf Not jd And MouseY()> 49 And MouseY()< 70
OpenURL "http://connect.creativelabs.com/openal/Downloads/oalinst.zip"
EndIf
SetColor 255,255,255
EndIf
GCCollect
Until KeyHit(KEY_ESCAPE)Or AppTerminate()
bj
EndFunction
Function dh()
Plot m/2,0
SetColor 255,255,0
glBegin GL_TRIANGLE_FAN
glVertex2f m/2,0
SetColor 255,50,75
glVertex2f 0,k
glVertex2f 0,0
glVertex2f m,0
glVertex2f m,k
glVertex2f 0,k
glEnd
EndFunction