;BCC - ozzi789
Global winx=1024,winy=768,player_x,player_y,player_y_size,player_x_size,star_img,floor_img,hud,fire_img,player_img,player_score,player_is_in_elevator,total_stars,level_start_time,star_w,star_h,bg,starttime_fall,tot_time_fall,speed_fall,speed_hit,player_jumping,starttime_jump,tot_time_jump,time,cur_level,bambus_used,bambus_img,lift_img,map_count,croak,gameend,player_y_org,timer,font_16,font_36,ding,playername$="Froggy",soundon=1,cur_level_pw$,bigbambus_img,firegfxflag=0,firegfxtime
Dim passwords$(50)
AppTitle playername$

Type wall
	Field x
	Field y
	Field w
	Field h
	Field bambus=0
	Field cycletime
	Field lasttime
	Field show
	Field fire
	Field notop
End Type
Type elevator
	Field x
	Field y
	Field w
	Field h
End Type
Type star
	Field x
	Field y
End Type

Graphics winx,winy,32,2
SetBuffer BackBuffer()


start()

ClsColor 20,30,100

Repeat 
	menu()
	While Not KeyHit(1)
		Cls	
			keyboard()

			check_oob()			
			
			check_win()
				
			render()
			
			ftime()
		WaitTimer timer	
		Flip 0 
	Wend 
Forever 

Function check_oob()
	If player_x<0 Or player_x>winx Or player_y<y Or player_y>winy
		player_dead(playername$+" has left the building...")
	EndIf 
End Function 


Function start()
	SeedRnd MilliSecs()
	map_count=get_mapinfos()

	croak=LoadSound("data/croak.wav")
	gameend=LoadSound("data/gameend.wav")
	ding=LoadSound("data/Click01.wav")

	lift_img=LoadImage("data/lift.png")
	
	player_img=LoadAnimImage("data/frog.png",30,30,0,2)
	MaskImage player_img,255,0,255
	player_x_size=ImageWidth(player_img)
	player_y_size=ImageHeight(player_img)
	
	star_img=LoadImage("data/star.png")
	star_x_size=ImageWidth(star_img)
	star_y_size=ImageHeight(star_img)
	
	bambus_img=LoadImage("data/bambus.png")
	fire_img=LoadAnimImage("data/fire.png",20,12,0,2)
	floor_img=LoadImage("data/floor.png")
	hud=LoadImage("data/hud.png")
	
	starttime_fall=MilliSecs()
	starttime_jump=MilliSecs()
	cur_level=49
	
	bigbambus_img=CopyImage (bambus_img)
	ScaleImage bigbambus_img,2,2
	
	font_16=LoadFont("Verdana",16)
	font_36=LoadFont("Verdana",36,1)
	SetFont (font_16)
	
	timer=CreateTimer(60)
End Function 


Function check_win()
	If player_score=total_stars
		Color 255,255,255
		Delay(500)
		Cls
		FlushKeys()
		Delay(100)
		If soundon=1 PlaySound(gameend)
		took_time=(MilliSecs()-level_start_time)/1000
		SetFont (font_36)
		Text winx/2,winy/2-30, playername$+" is safe for now!",1,1
		SetFont (font_16)
		Text winx/2,(winy/2)+20,"Time passed: "+took_time+" seconds",1,1
		Text winx/2,(winy/2)+40,"Password for this level is: "+cur_level_pw$
		Flip 
		Delay(500)
		WaitKey 
		FlushKeys()
		cur_level=cur_level+1
		If Int(Chr(cur_level))>map_count Then 
			SetFont(font_36)
			While Not KeyHit(1)
				Cls
				DrawImage player_img,winx/2,winy/2-100,player_jumping
				If MilliSecs()>screentime+300
					screentime=MilliSecs()
					player_jumping=Not player_jumping
				EndIf 
				Text winx/2,winy/2, "YOU HAVE SAVED "+playername$+", CONGRATULATIONS!",1,1
				Text winx/2,winy/2+40,"Press ESC to end",1,1
				Flip 30
			Wend
			Delay(1000)
			WaitKey()
			menu()
		EndIf
		
		load_map(Chr(cur_level))
	EndIf
End Function 


Function get_mapinfos()
	Repeat
		filehandle=OpenFile("maps/"+Chr(49+x))
		If filehandle=0
			Return x
		Else
			x=x+1
			ReadLine(filehandle)
			ReadLine(filehandle)
			ReadLine(filehandle)
			passwords$(x)=ReadLine(filehandle)
		EndIf 
		CloseFile filehandle
	Forever
End Function


Function render()
	Local wallcounter=0
	For w.wall=Each wall
		wallcounter=wallcounter+1
		If w\lasttime+w\cycletime<MilliSecs()
			w\lasttime=MilliSecs()
			w\show=w\show+1
			If w\show>1 Then w\show=0
		EndIf 
		
		If firegfxtime+500<MilliSecs()
			firegfxtime=MilliSecs()
			firegfxflag=Not firegfxflag
		EndIf 
		
		If w\bambus=0 
			If w\show=1 Or w\cycletime=0
				If w\fire=1
					Viewport w\x,w\y,w\w,w\h
					TileImage fire_img,0,0,firegfxflag
					Viewport 0,0,winx,winy
				Else
					Viewport w\x,w\y,w\w,w\h
					TileImage floor_img
					Viewport 0,0,winx,winy
				EndIf 
			EndIf 
		Else
			For i=0 To 4
				DrawImage bambus_img,w\x+(i*20),w\y
			Next		
		EndIf 
	Next
	Color 100,100,200
	For e.elevator=Each elevator
		player_is_in_elevator=0
		For i=0 To e\h/12
			DrawImage lift_img,e\x,e\y+(i*12)
		Next
		If player_x>e\x-(e\w) And player_x<e\x+e\w And player_y>e\y And player_y<e\y+e\h
			player_y=player_y-15
			player_is_in_elevator=1
		EndIf 
		If player_x>e\x-(e\w) And player_x<e\x+e\w And player_y>e\y-40 And player_y<e\y+20 Then jump(2)
	Next
	Color 255,255,255
	If nocollide() And player_is_in_elevator=0 And (level_start_time+300<MilliSecs())
		If tot_time_fall=0 Then tot_time_fall=1
		If level_start_time+300<MilliSecs()
			speed_fall=(0.05*(tot_time_fall)^2+1)
		Else
			speed_fall=0
		EndIf 
		If speed_fall>5 Then speed_fall=5
		player_y=player_y+speed_fall
	EndIf
	
	do_stars()
	DrawImage player_img,player_x,player_y,player_jumping	
	

	width=(winx/2-((total_stars*15)/2)-15)+(1*15) -50
	width2=(winx/2-((total_stars*15)/2)-15)+((total_stars+1)*15) +50
	
	Color 102,189,15
	Viewport width,10,width2-width,60
	TileImage hud
	Rect width,10,width2-width,60,0
	Viewport 0,0,winx,winy
	
	Color 200,200,100
	For i=1 To total_stars
		If i>player_score
			Oval (winx/2-((total_stars*15)/2)-15)+(i*15),15,15,15
		Else
			DrawImage star_img,(winx/2-((total_stars*15)/2)-15)+(i*15),15
		EndIf 
	Next
	For i=0 To 2-bambus_used
		DrawImage bambus_img,(40*i)+winx/2-50,45
	Next 
End Function 


Function score(reset=0)
	player_score=player_score+1
	If reset<>0 Then player_score=0:Return
	If soundon=1 PlaySound ding
End Function

Function do_stars()
	For s.star =Each star
		DrawImage star_img,s\x,s\y
		If ImagesOverlap(player_img,player_x,player_y,star_img,s\x,s\y)
			Delete s.star
			score()
		EndIf
	Next
End Function


Function keyboard()

	If level_start_time+300>MilliSecs()
		player_y=player_y_org
	EndIf

	done=0
	
	If bambus_used<3
		mx=player_x
		my=player_y-20
		While KeyDown (16) 
			Cls
			If KeyDown(200) Then my=my-1
			If KeyDown(208) Then my=my+1
			If KeyDown(203) Then mx=mx-1
			If KeyDown(205) Then mx=mx+1
			render()
			Rect mx,my,100,20,0
			Flip
			done=1
		Wend 
	EndIf 
	
	If done=1
		bambus_used=bambus_used+1
		w.wall=New wall
		w\x=mx
		w\y=my
		w\w=100
		w\h=12
		w\bambus=1
	EndIf 
		
	If KeyHit(14)
		load_map(Chr(cur_level))
	EndIf	
				
	If KeyHit(57) And player_jumping=0 
		If soundon=1 PlaySound croak
		player_jumping=1
		player_y=player_y-10
	Else
		If Not nocollide() 
			starttime_jump=MilliSecs()
		EndIf 
	EndIf 
	If KeyDown(30)
		If nocollide_right()=1
			player_x=player_x-2
		EndIf 
	EndIf 
	If KeyDown(32) 
		If nocollide_left()=1
			player_x=player_x+2
		EndIf 
	EndIf 
	If player_jumping=1
		jump(10)
	EndIf 
	If tot_time_jump>5
		player_jumping=0
	EndIf 
	If nocollide_top()=0
		player_jumping=0
	EndIf 
End Function 

Function jump(speed)
	If tot_time_jump=0 Then tot_time_jump=1
	player_y=player_y-(8-tot_time_jump*2)
End Function 

Function ftime()
	time=MilliSecs()
	tot_time_fall=(time - starttime_fall)/100.0
	tot_time_jump=(time - starttime_jump)/100.0
End Function


Function nocollide_top()
	For w.wall= Each wall	
		If player_x>w\x-player_x_size-1 And player_x<w\x+w\w And player_y<w\y+w\h+(player_y_size/2) And player_y>w\y+w\h And (w\show=1 Or w\cycletime=0) And w\notop=0
			If w\fire=1 Then player_dead("You tried To bath in fire") 
			Return 0
		EndIf 
	Next
	Return 1
End Function


Function nocollide_left()
	For w.wall= Each wall	
		If player_x<w\x And player_x>w\x-player_x_size-4 And player_y+player_y_size>w\y And player_y<w\y+w\h And (w\show=1 Or w\cycletime=0)
			If w\fire=1 Then player_dead("You tried to bath in fire") 
			Return 0
		EndIf 
	Next
	Return 1
End Function

Function nocollide_right()
	For w.wall= Each wall	
		If player_x>w\x+w\w And player_x<w\x+w\w+5 And player_y+player_y_size>w\y And player_y<w\y+w\h And (w\show=1 Or w\cycletime=0)
			If w\fire=1 Then player_dead("You tried to bath in fire") 
			Return 0
		EndIf 
	Next
	Return 1
End Function

Function nocollide()
	For w.wall= Each wall	
		If w\x-player_x_size<player_x And w\x+w\w>player_x And w\y<player_y+player_y_size+5 And w\y+w\h>player_y And (w\show=1 Or w\cycletime=0)
			speed_hit=speed_fall
			starttime_fall=MilliSecs()
			If w\fire=1 Then player_dead("You tried to bath in fire") 
			Return 0
		EndIf 
	Next
	Return 1
End Function


Function player_dead(message$)
	FlushKeys()
	SetFont(font_36)
	ClsColor 245,30,10
	Cls
	ClsColor 20,30,100
	Text winx/2,winy/2,message$,1,1
	Flip
	WaitKey
	SetFont(font_16)
	load_map(Chr(cur_level))
End Function 
	

Function clean_up()
	bambus_used=0
	For w.wall=Each wall
		Delete w.wall
	Next
	For sc.star=Each star
		Delete sc.star
	Next
	For ea.elevator=Each elevator
		Delete ea.elevator
	Next
	score(1)
	total_stars=0
End Function

Function load_map(name$)
	clean_up()

	file$="maps/"+name$
	DebugLog file$
	
	maphandle=OpenFile (file$)

	player_x=Int(ReadLine(maphandle))
	player_y=Int(ReadLine(maphandle))
	player_y_org=player_y
	introtext$=ReadLine(maphandle)
	cur_level_pw$=ReadLine(maphandle)
	While 1
		typ$=ReadLine(maphandle)
		Select typ$
			Case "wall"
				x=Int(ReadLine(maphandle))
				y=Int(ReadLine(maphandle))
				w=Int(ReadLine(maphandle))
				h=Int(ReadLine(maphandle))
				ct=Int(ReadLine(maphandle))
				firem=Int(ReadLine(maphandle))
				nt=Int(ReadLine(maphandle))
				a.wall=New wall
				a\x=x
				a\y=y
				a\w=w
				a\h=h
				a\cycletime=ct
				a\lasttime=MilliSecs()
				a\fire=firem
				a\notop=nt
			Case "star"
				x=Int(ReadLine(maphandle))
				y=Int(ReadLine(maphandle))
				s.star=New star
				s\x=x
				s\y=y
				total_stars=total_stars+1
			Case "elevator"
				x=Int(ReadLine(maphandle))
				y=Int(ReadLine(maphandle))
				w=Int(ReadLine(maphandle))
				h=Int(ReadLine(maphandle))
				e.elevator=New elevator
				e\x=x
				e\y=y
				e\w=w
				e\h=h
			Case "ENDEGELAENDE"
				Exit
		End Select
	Wend 
	Cls
	FlushKeys()
	SetFont(font_36)
	Color 255,255,255
	Text winx/2,winy/2,introtext$,1,1
	SetFont(font_16)
	Flip 
	Delay(2000)
	level_start_time=MilliSecs()

End Function 

Function menu()
	FlushKeys()
	selected=3
	Repeat
		Cls
		TileImage bigbambus_img
		Color 40,150,30
		Rect winx/2-200,winy/2-300,400,600
		Color 0,0,0
		SetFont (font_36)
		Text winx/2,winy/4,playername$,1,1
		DrawImage player_img,winx/2,winy/5,0
		SetFont (font_16)
		Color 255,255,255
		Text winx/2-20,winy/2-60,"Play"
		Text winx/2-20,winy/2-40,"Password"
		Text winx/2-20,winy/2-20,"Help"
		Text winx/2-20,winy/2,"End"
		Text winx/2-40,winy/2-selected*20,">"
		Text winx/2,winy/2+80,"Code&Gfx by ozzi789 for BCC #60",1,0
		If soundon=1 Then info_sound$="ON" Else info_sound$="OFF"
		Text winx/2+110,winy/2+270, "Sound is "+info_sound$
		If KeyHit(50) 
			If soundon=False Then PlaySound ding
			soundon= Not soundon
		EndIf 
		If KeyHit(17) Then selected=selected+1
		If KeyHit(31) Then selected=selected-1
		If selected>3 Then selected=0
		If selected<0 Then selected=3
		If KeyHit(1) Then End 
		If KeyHit(28)
			Select selected
				Case 3
					load_map(Chr(cur_level))
					Exit 
				Case 2
					result=password()
					If result=1 Then Return 
				Case 1
					showhelp()
				Case 0	
					End
			End Select 
		EndIf 
		WaitTimer timer
		Flip 0
	Forever
End Function




Type fcoin
	Field x
	Field y
	Field speed#
End Type




Function showhelp()
	For f.fcoin=Each fcoin
		Delete f.fcoin
	Next
	For x=1 To 20
		f.fcoin=New fcoin
		f\x=Rand(20,1000)
		f\y=-20-Rand(2,50)
		f\speed#=Rnd(1,6)
	Next
	While Not KeyHit(1)
		Cls
		FlushKeys()
		;TileImage bigbambus_img
		For f.fcoin=Each fcoin
			f\y=f\y+f\speed#
			DrawImage star_img,f\x,f\y
			If f\y>780 Then f\y=-20-Rand(2,50) : f\speed#=Rnd(1,6)
		Next	
		Color 40,150,30
		Rect winx/2-200,winy/2-300,400,600
		Color 0,0,0
		SetFont (font_36)
		Text winx/2-190,winy/2-200,"HELP"
		Color 255,255,255
		SetFont (font_16)
		Text winx/2-190,winy/2-120,"Use WSAD to move "+playername$,0,1
		Text winx/2-190,winy/2-60,"Press SPACE to jump",0,1
		Text winx/2-190,winy/2,"Hold Q to place bamboo and use Arrowkeys to move it",0,1
		Text winx/2-190,winy/2+60,"Use backspace to reload level",0,1
		Text winx/2-190,winy/2+120,"Press M in the main menu to toggle sound",0,1
		Text winx/2-190,winy/2+180,"Press ESC to return to the main menu",0,1
		Flip
	Wend 
End Function 

Function password()
	Cls 
	FlushKeys()
	pw$=Input("Password > ")
	For x=1 To map_count
		DebugLog passwords$(x)
		If pw$=passwords$(x) And pw$<>""
			cur_level=48+x
			load_map(Chr(48+x))
			Return 1
		EndIf 
	Next
	Cls 
	Text 0,40, "WRONG PASSWORD!" 
	Flip
	WaitKey 
	FlushKeys()
	Return 0
End Function


;~IDEal Editor Parameters:
;~C#BlitzPlus